function isHat(%this)
{
	if(isObject("Clicker_Hat_" @ %this))
	{
		return true;
	}
	return false;
}

function getRealHatName(%this)
{
	return strreplace(nameToID("Clicker_Hat_" @ %this).getName(), "Clicker_Hat_", "");
}

function getHatDatablock(%this)
{
	%this = strreplace(%this, "Clicker_Hat_", ""); //just incase
	return nameToID("Clicker_Hat_" @ %this);
}

function mountHat(%client)
{
	%player = %client.player;
	if(!isObject(%player))
	{
		return;
	}
	
	%name = $Clicker_Shop_Hat_CurrentHat[%client.bl_id];
	if(%name $= "")
	{
		%player.unmountImage(2);
		%client.applyBodyParts();
		%client.applyBodyColors(1);
		return;
	}
	
	%hat = nameToID("Clicker_Hat_" @ %name);
	if(!isObject(%hat))
	{
		return;
	}
	
	%player.unmountImage(2);
	%player.mountImage(%hat, 2);
	
	for(%a = 0; $hat[%a] !$= ""; %a++)
	{
		%player.hideNode($hat[%a]);
		%player.hideNode($accent[%a]);
	}
}

//DATABLOCKS
datablock ShapeBaseImageData(Clicker_Hat_Bandage)
{
	cost = 10000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Bandage.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 10 10";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Builder)
{
	cost = 10000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Builder.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0.02 0.3";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Cigar)
{
	cost = 10000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Cigar.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 10 10";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Swag)
{
	cost = 40000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Dark.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Headphones)
{
	cost = 30000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Headphones.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "-0.03 0 0.24";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Jason)
{
	cost = 50000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Jason.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "-1 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = true;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_PaperBag)
{
	cost = 20000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/PaperBag.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Beret)
{
	cost = 30000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Beret.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Shades)
{
	cost = 75000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/CoolShades.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Bandit)
{
	cost = 20000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Bandit.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 -0.4 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Doctor)
{
	cost = 50000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Doctor.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Batman)
{
	cost = 70000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/batman.dts";
	emap = false;
	mountPoint = $HeadSlot;
	offset = "0 0 0.24";
	eyeOffset = "-5 -5 -5";
	rotation = "0 0 0 0";
	scale = "1 1 1";
	doColorShift = false;
	colorShiftColor = "0 0 0 1";
};

datablock ShapeBaseImageData(Clicker_Hat_Dastardly)
{
	cost = 100000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/DastardlyHair.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Trucker)
{
	cost = 30000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/TruckerHair.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Vet)
{
	cost = 50000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Vet.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_BigHead)
{
	cost = 70000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/BigHead.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Cap)
{
	cost = 25000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Trucker.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Police)
{
	cost = 35000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/Police.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_Soda)
{
	cost = 40000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/SodaHat.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 0.4";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
	colorShiftColor = "0.392 0.196 0.0 1.000";
};

datablock ShapeBaseImageData(Clicker_Hat_TopHat)
{
	cost = 50000;
	shapeFile = "Add-Ons/GameMode_Brick_Clicker/hats/TopHat.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 0.1";
	eyeOffset = "0 0 10";
	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";
	doColorShift = false;
	colorShiftColor = "1.000 1.000 1.000 1.000";
};