%package = "ClickerPackage";

if(isPackage(%package))
{
	deactivatePackage(%package);
}

package ClickerPackage
{
	function fxDTSBrick::OnActivate(%obj, %player, %client, %pos, %vec)
	{
		Parent::OnActivate(%obj, %player, %client, %pos, %vec);
		%data = %obj.getDataBlock();
		if(%data.getid() == brickClickerBrickData.getId())
		{
			%points = $Clicker_ScorePerClick_[%client.BL_ID];
			%client.addscore(%points, "Clicking");
			$Clicker_Score_ClickerBrick += 1;
			%client.setHubPrint();
		}
		return;
	}

	function fxDTSBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);

		if(!%brick.isPlanted || !isObject(%brick) || !isObject(%client = %brick.getGroup().client))
			return;
		
		%data = %brick.getDataBlock();
		
		if(%data.getid() == brickClickerBrickData.getId())
		{
			if(!%client.isAdmin)
			{
				commandToClient(%client, 'centerPrint', "You must be an admin to place this brick.", 3);
				%brick.schedule(0, "delete");
			}
		}
		return;
	}
	
	function GameConnection::spawnPlayer(%this)
	{
		Parent::spawnPlayer(%this);
		
		%this.player.tool[0] = hammerItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 0, hammerItem.getID());
		%this.player.tool[1] = wrenchItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 1, wrenchItem.getID());
		%this.player.tool[2] = printGun.getID();
		messageClient(%this, 'MsgItemPickup', '', 2, printGun.getID());
		%this.player.tool[3] = duplorcatorItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 3, duplorcatorItem.getID());
		%this.player.tool[4] = fillCanItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 4, fillCanItem.getID());
		
		if(mfloor($Clicker_ScorePerClick_[%this.BL_ID]) <= 0)
		{
			$Clicker_ScorePerClick_[%this.BL_ID] = 1;
		}
		if(mfloor($Clicker_Score_[%this.BL_ID]) < 0)
		{
			$Clicker_Score_[%this.BL_ID] = 0;
		}
		%this.score = mfloor($Clicker_Score_[%this.BL_ID]);
		%this.setHubPrint();
		mountHat(%this);
		return;
	}
	
	function serverCmdTeamMessageSent(%this, %msg)
	{
		messageClient(%this, '', "\c6Please use the normal chat.");
		return;
	}
	
	function ServerCmdPlantBrick(%client)
	{
		// Call the default version of the plant function
		// Compare the player's brick count before and after to see if plant succeeded

		%player = %client.player;
		if(!isObject(%player))
			return 0;

		%tempBrick = %player.tempBrick;
		if(!isObject(%tempBrick))
			return 0;

		%preCount = %client.brickGroup.getCount();
		Parent::ServerCmdPlantBrick(%client);
		%count = %client.brickGroup.getCount();
		if(%count <= %preCount)
			return;

		// The last brick in their brick group should be the one they just planted
		%plantedBrick = %client.brickGroup.getObject(%count - 1);

		// Special rules for the first brick planted, so we can get the build started
		// have to do some messed up stuff here because temp bricks count towards brickcount now
		// this can still be broken if people are spamming non 64x bricks because of the delay in deleting
		if(getBrickCount() <= 40)
		{
			%tempBrickCount = 0;
			for(%i = 0; %i < clientGroup.getCount(); %i++)
			{
				%cl = clientGroup.getObject(%i);

				for(%j = 0; %j < %cl.brickGroup.getcount(); %j++)
				{
					%brick = %cl.brickGroup.getObject(%j);
					if(%brick.isDead())
						%tempBrickcount++;
				}

				if(isObject(%cl.player))
					if(isObject(%cl.player.tempBrick))
						%tempBrickCount++;            
			}

			if(getBrickCount() - %tempBrickCount <= 1)
			{
				// if they managed to plant the first brick not on the ground then something is wrong
				if(%plantedBrick.getDistanceFromGround() != 0)
				{
					error("ERROR: [TerrainBuildRulesPackage]ServerCmdPlantBrick() - first brick somehow not planted on the ground");
					return;
				}
            
				// must be a 64x plate
				if(%plantedBrick.getDataBlock().getID() != brick32x32fData.getID())
				{
					CommandToClient(%client, 'MessageBoxOK', "Invalid Brick", "You must start with a 32x32 Base<bitmap:base/client/ui/brickIcons/32x32 Base>");
					%plantedBrick.killBrick();
					return;
				}

				// they cant place clicker bricks if they arent admin
				if(%plantedBrick.getDataBlock().getID() == brickClickerBrickData.getId())
				{
					if(!%client.isAdmin)
					{
						%plantedBrick.killBrick();
					}
					return;
				}

				return;
			}
		}

		// they cant place clicker bricks if they arent admin
		if(%plantedBrick.getDataBlock().getID() == brickClickerBrickData.getId())
		{
			if(!%client.isAdmin)
			{
				%plantedBrick.killBrick();
			}
			return;
		}

		// They planted a brick.  Was it on the ground?
		if(%plantedBrick.getDistanceFromGround() != 0)
			return;

		// It was on the ground.  It better be a 64x baseplate.
		if(%plantedBrick.getDataBlock().getID() != brick32x32fData.getID())          //Note: comparing the two datablock ID numbers is faster than doing a string compare on their names
		{
			CommandToClient(%client, 'MessageBoxOK', "Invalid Brick", "You must start with a 32x32 Base<bitmap:base/client/ui/brickIcons/32x32 Base>");
			%plantedBrick.killBrick();
			return;
		}

		// Also, it better be lined up with an existing baseplate
		// Search for nearby plates and check their relative position
		%pos = %plantedBrick.getPosition();
		%box = "16.1 16.1 0.1";
		%mask = $TypeMasks::FxBrickAlwaysObjectType;

		%plantX = getWord(%plantedBrick.getPosition(), 0);
		%plantY = getWord(%plantedBrick.getPosition(), 1);

		initContainerBoxSearch(%pos, %box, %mask);
		while (%searchObj = containerSearchNext())
		{	
			if(%searchObj.getDataBlock().getID() != brick32x32fData.getID())
				continue;

			if(%searchObj.getDistanceFromGround() != 0)
				continue;

			if(!%searchObj.isPlanted())
				continue;

			if(%searchObj.isDead())
				continue;

			if(%searchObj == %plantedBrick)
				continue;

			//To be lined up, the x or y position must be the same
			%searchX = getWord(%searchObj.getPosition(), 0);
			%searchY = getWord(%searchObj.getPosition(), 1);

			// Note: We compare with subtraction like this because direct comparison with "==" on floating point numbers is not reliable
			if(mAbs(%searchX - %plantX) < 0.05 || mAbs(%searchY - %plantY) < 0.05 )
				return;
		}

		//If we got this far it must not have been lined up with any existing plates
		CommandToClient(%client, 'MessageBoxOK', "Invalid Placement", "You must line up your baseplate with the existing grid.");
		%plantedBrick.killBrick();
		return;
	}
   
	function serverCmdMessageSent(%client,%msg)
	{
		%oldPrefix = %client.clanPrefix;
		if($Clicker_Shop_Title_CurrentTitle[%client.bl_id] !$= "")
			%client.clanPrefix = "\c7" @ $Clicker_Shop_Title_CurrentTitle[%client.bl_id] @ " \c7" @ %oldPrefix;
		
		%oldSuffix = %client.clanSuffix;
		if(%client.isAdmin)
		{
			%client.clanSuffix = %oldSuffix @ " \c2A";
			if(%client.isSuperAdmin)
			{
				%client.clanSuffix = %oldSuffix @ " \c2SA";
			}
		}
		Parent::serverCmdMessageSent(%client,%msg);
		%client.clanPrefix = %oldPrefix;
		%client.clanSuffix = %oldSuffix;
		
		return;
	}
};

activatePackage(%package);